# SoCalculator Class Reference
[Engine classes]

`#include <Inventor/engines/SoCalculator.h>`

Inheritance diagram for SoCalculator:

List of all members.

## Detailed Description

General purpose calculator for floats and 3D float vectors.

The SoCalculator uses the values from the input fields (which are either single floating point values or vectors) as variables in the free-form engine expressions and places the results on the output fields.

The engine has sixteen input fields; eight scalar inputs (a, b, c, d, e, f g, and h), and eight vector inputs (A, B, C, D, E, F, G, and H).

There are eight output fields; four scalar outputs (oa, ob, oc, and od), and four vector outputs (oA, oB, oC, and oD).

The expression syntax is quite similar to C/C++, with a very limited set of keywords and functions.

An example:

      oa = a * (0.5 + b) / c

Will multiply the value in a with the value in b plus 0.5, divide that result with c, and place the result in oa. Since this is an engine, the expression will only be evaluated when someone attempts to read the value in oa, not every time an input in changed.

All inputs are multi-fields, and if there are several values in an input, the expression will be evaluated once for every input field value, and the output will create as many values as there are input field values.

If there is more than one input field, and the input fields do not have the same number of values, the engine will create as many output values as the input field with the biggest number of values. When the index get out of bounds for some other input field, the last field value will be used.

Vector expressions are similar to scalar expression. An example:

      oA = A + vec3f(1.0, 0.0, 0.0) * B

Will take the vector in A, add the value in B multiplied with (1,0,0), and place the result in oA.

In addition to regular arithmetics, the SoCalculator syntax also includes some functions.

Scalar functions:

- cos(x) - cosine function (x in radians)
- sin(x) - sinus function
- tan(x) - tangent function
- acos(x) - arc cosine function
- asin(x) - arc sinus function
- atan(x) - arc tangent function
- atan2(y, x) - arc tangent function of two variables (y, x).
- cosh(x) - hyperbolic cosine function
- sinh(x) - hyperbolic sinus function
- tanh(x) - hyperbolic tangent function
- sqrt(x) - square root function
- pow(x,y) - x raised to the power of y
- exp(x) - e to the power of x
- log(x) - natural logarithm of x
- log10() - base-10 logarithm of x
- ceil(x) - rounds x upwards to the nearest integer
- floor(x) - rounds x downwards to the nearest integer
- fabs(x) - absolute value
- fmod(x, y) - remainder of dividing x by y
- rand(x) - pseudo-random value between 0 and 1

Vector functions:

- cross(x, y) - cross product of x and y
- dot(x,y) - dot product of x and y (returns scalar value)
- length(x) - length of x (returns scalar value)
- normalize(x) - returns normalized version of x
- x[y] - access components in x (y should be a scalar value in the range [0,2])

There are also some named constants that can be used:

- MAXFLOAT
- MINFLOAT
- M_E
- M_LOG2E
- M_LOG10E
- M_LN2
- M_PI
- M_SQRT2 - sqrt(2)
- M_SQRT1_2 - sqrt(1/2)

The only control flow available is the ? operator. An example:

      oa = (a > b) ? (a * 0.5) : (b * c)

(The parentheses are not necessary, they're there just to make the example easier to read)

In addition to the standard comparators (<, >, <=, >=, ==, !=), you can also use && (AND) and || (OR) to combine expression, and the unary ! (NOT) operator.

One final thing worth mentioning is the temporary variables. There exists sixteen temporary variables that can be used in expressions. ta, tb, tc, td, te, tf, tg, and th are scalar variables, and tA, tB, tC, tD, tE, tF, tG, and tH are vector variables. They are usually used when you have more than one expression that should be evaluated in order.

An example with three expressions:

      ta = a * b; tb = c + d; tc = e - f
      tA = vec3f(ta, tb, tc) + A
      oA = tA * B

The example just shows how temporary variables can be used to make your expressions easier to read. Please note that it's possible to have several statements in one expression. You just separate them with semicolons.

## Public Member Functions

| SoCalculator (void)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoMFFloat | a
SoMFFloat | b
SoMFFloat | c
SoMFFloat | d
SoMFFloat | e
SoMFFloat | f
SoMFFloat | g
SoMFFloat | h
SoMFVec3f | A
SoMFVec3f | B
SoMFVec3f | C
SoMFVec3f | D
SoMFVec3f | E
SoMFVec3f | F
SoMFVec3f | G
SoMFVec3f | H
SoMFString | expression
SoEngineOutput | oa
SoEngineOutput | ob
SoEngineOutput | oc
SoEngineOutput | od
SoEngineOutput | oA
SoEngineOutput | oB
SoEngineOutput | oC
SoEngineOutput | oD

## Protected Member Functions

| ~SoCalculator (void)
virtual void | inputChanged (SoField *which)

## Constructor & Destructor Documentation

SoCalculator::SoCalculator | ( | void |  | ) |

| Constructor.

SoCalculator::~SoCalculator | ( | void |  | ) | `[protected]`

| Destructor.

## Member Function Documentation

void SoCalculator::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoEngine.

void SoCalculator::inputChanged | ( | SoField * | which | ) | `[protected, virtual]`

| Called when an input is changed. The default method does nothing, but subclasses may override this method to do the The Right Thing when a specific field is changed. Reimplemented from SoEngine.

## Member Data Documentation

SoMFFloat SoCalculator::a

| Input floating point value for the expressions.

SoMFFloat SoCalculator::b

| Input floating point value for the expressions.

SoMFFloat SoCalculator::c

| Input floating point value for the expressions.

SoMFFloat SoCalculator::d

| Input floating point value for the expressions.

SoMFFloat SoCalculator::e

| Input floating point value for the expressions.

SoMFFloat SoCalculator::f

| Input floating point value for the expressions.

SoMFFloat SoCalculator::g

| Input floating point value for the expressions.

SoMFFloat SoCalculator::h

| Input floating point value for the expressions.

SoMFVec3f SoCalculator::A

| Input vector with three floating point values for the expressions.

SoMFVec3f SoCalculator::B

| Input vector with three floating point values for the expressions.

SoMFVec3f SoCalculator::C

| Input vector with three floating point values for the expressions.

SoMFVec3f SoCalculator::D

| Input vector with three floating point values for the expressions.

SoMFVec3f SoCalculator::E

| Input vector with three floating point values for the expressions.

SoMFVec3f SoCalculator::F

| Input vector with three floating point values for the expressions.

SoMFVec3f SoCalculator::G

| Input vector with three floating point values for the expressions.

SoMFVec3f SoCalculator::H

| Input vector with three floating point values for the expressions.

SoMFString SoCalculator::expression

| Mathematical expressions for the calculator.

SoEngineOutput SoCalculator::oa

| (SoMFFloat) Output value with result from the calculations.

SoEngineOutput SoCalculator::ob

| (SoMFFloat) Output value with result from the calculations.

SoEngineOutput SoCalculator::oc

| (SoMFFloat) Output value with result from the calculations.

SoEngineOutput SoCalculator::od

| (SoMFFloat) Output value with result from the calculations.

SoEngineOutput SoCalculator::oA

| (SoMFVec3f) Output value with result from the calculations.

SoEngineOutput SoCalculator::oB

| (SoMFVec3f) Output value with result from the calculations.

SoEngineOutput SoCalculator::oC

| (SoMFVec3f) Output value with result from the calculations.

SoEngineOutput SoCalculator::oD

| (SoMFVec3f) Output value with result from the calculations.

The documentation for this class was generated from the following files:

- SoCalculator.h
- SoCalculator.cpp